#include <windows.h>
#include <cstdio>

using namespace std;

DWORD WINAPI MostrarHora( void* par) {
    bool *salir = (bool*)par;  // Recuperar el parmetro, un puntero a bool
    SYSTEMTIME st;             // Estructura para obtener la hora
    COORD dwPos = {67,1};      // Coordenadas de pantalla para mostrar hora
    int seg = 0;               // Variable auxiliar para detectar cambio de segundo

    do {
        // Esperamos a que cambie el segundo:
        while(seg == st.wSecond) {
            GetLocalTime(&st);
            Sleep(100);
        }
        // Colocar el cursor:
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        // Mostrar hora:
        printf("%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
        // Almacenar el segundo actual:
        seg = st.wSecond;
    } while(!*salir); // Repetir hasta que salir sea true

    printf("\nAbandonando el hilo\n");
    return 0;
}

int main() {
    HANDLE hHora;
    bool salir = false;

    // Crear el hilo
    hHora = CreateThread( 0, 0, MostrarHora, (void*)&salir, 0, 0);

    // Esperar a que el usuario pulse una tecla, el hilo se sigue ejecutando:
    printf("Pulsa una tecla para salir");
    getchar();
    salir = true;

    // Dejar tiempo a que termine el hilo:
    Sleep(2000);

    // Liberar el manipulador:
    CloseHandle(hHora);
    return 0;
}
